'// Arguments:
' /excl:"<excl1;excl2> - lists of exclusions
' /drop - drop filtered nodes

Option Explicit

Dim fso, WshShell, oInstaller
Dim scriptdir, scanpath, cmd, snap1, snap2, difFile, diffName, bFiltering, pkgdir
Set fso = WScript.CreateObject("Scripting.Filesystemobject")
Set WshShell = WScript.CreateObject("Wscript.Shell")
Set oInstaller = CreateObject("WindowsInstaller.Installer")

scriptdir = fso.GetParentFolderName(WScript.ScriptFullName) & "\"

pkgdir = fso.GetParentFolderName(fso.GetParentFolderName(fso.GetParentFolderName(WScript.ScriptFullName))) & "\Packages"
if not fso.FolderExists(pkgdir) then
    MsgBox pkgdir & " folder doesn't exist!", vbError
    WScript.Quit 3
end if

snap1 = pkgdir & "\snap1.snap"
snap2 = pkgdir & "\snap2.snap"

If Not fso.FileExists(snap1) Then
	MsgBox "File [" & snap1 & "] does not exist!", vbError, "Snapshot not found!"
	WScript.Quit 3
ElseIf Not fso.FileExists(snap2) Then
	MsgBox "File [" & snap2 & "] does not exist!", vbError, "Snapshot not found!"
	WScript.Quit 3
End If

diffName = "difFile"
diffName = InputBox("Project File Name:", "Enter Project File Name", diffName)
if Len(diffName) < 1 then
    WScript.Quit 
end if
difFile = pkgdir & "\" & diffName & ".xml"

bFiltering = False
if MsgBox("Do you want to exclude system-level resources from the differnce file?", vbYesNo) = vbYes then
    bFiltering = True
end if

If fso.FileExists(difFile) Then fso.DeleteFile difFile, True

cmd = """" & scriptdir & "ssCompare.exe"" """ & snap1 & """ """ & snap2 & """ """ & difFile & """ -getallreg -l """ & pkgdir & "\makediff.log"""

WshShell.Run cmd, 1, True

If Not fso.FileExists(difFile) Then
	MsgBox "File [" & difFile & "] does not exist!", vbError, "DifFile not found!"
	WScript.Quit 3
End If

Dim xmldoc, nodes, node, rxLnk
Set xmldoc = WScript.CreateObject("msxml2.domdocument")
Set rxLnk = New RegExp
rxLnk.IgnoreCase = True
rxLnk.Pattern = "\.lnk$"

xmldoc.load difFile
Set nodes = xmldoc.selectNodes("//file")
For Each node In nodes
	If rxLnk.Test(node.getAttribute("id")) Then
		'WScript.Echo node.getAttribute("id")
		expandShortcut node
	End If
Next

Function expandShortcut(ByRef oNode)
	Dim path, tNode, argNode, rxAdvtSh, Shortcut, oShortcut
	path = oNode.getAttribute("id")
	Set tNode = oNode
	Do While Not IsNull(tNode.parentNode)
		Set tNode = tNode.parentNode
		If tNode.baseName <> "dir" Then Exit Do
		path = tNode.getAttribute("id") & "\" & path
	Loop
	If Not fso.FileExists(path) Then Exit Function
	
	oNode.setAttribute "type", "lnk"
	
	Set Shortcut = WshShell.CreateShortcut(path)
	Set tNode = oNode.appendChild(xmldoc.createElement("shortcut"))
	tNode.setAttribute "target",Shortcut.TargetPath
	tNode.setAttribute "descr",Shortcut.Description
	tNode.setAttribute "hotkey",UCase(Shortcut.Hotkey)
	tNode.setAttribute "icon_path",Shortcut.IconLocation
	tNode.setAttribute "work_dir",Shortcut.WorkingDirectory
	tNode.setAttribute "wnd_style",Shortcut.WindowStyle
	
	'// Process arguments
	Dim  arg, args, argpos, quotarg, i, bQuot
	quotarg = Empty
	args = Trim(Shortcut.Arguments)
	If args <> "" Then
		argpos = 1
		For Each i In Split(args," ")
			arg = i
			bQuot = Not IsEmpty(quotarg)
			If Left(arg,1)="""" Then
				bQuot = True
				If Right(arg,1) = """" Then
					arg = Mid(arg,2,Len(arg)-2)
				Else
					quotarg = arg
				End If
			ElseIf Right(arg,1) = """" Then
				arg = quotarg & " " & arg
				arg = Mid(arg,2,Len(arg)-2)
				quotarg = Empty
			ElseIf Not IsEmpty(quotarg) Then
				quotarg = quotarg & " " & arg
			End If
			If IsEmpty(quotarg) Then
				Set argNode = tNode.appendChild(xmldoc.createElement("argument"))
				argNode.setAttribute "pos", argpos
				argNode.setAttribute "value", arg
				If bQuot Then
					argNode.setAttribute "quotes", 1
				Else
					argNode.setAttribute "quotes", 0
				End If
				argpos = argpos + 1
			End If				
		Next
	End If
	
	'// Process advertized shortcuts
	Set rxAdvtSh = New RegExp
	rxAdvtSh.IgnoreCase = True
	rxAdvtSh.Pattern = Replace(WshShell.ExpandEnvironmentStrings("%SystemRoot%"),"\","\\") & "\\Installer\\\{[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}\}\\.+"
	
	If rxAdvtSh.Test(Shortcut.TargetPath) Then
		Set oShortcut = oInstaller.ShortcutTarget(path)
		tNode.setAttribute "target",oInstaller.ComponentPath(oShortcut.StringData(1),oShortcut.StringData(3))
		Set oShortcut = Nothing
	End If
	Set Shortcut = Nothing
	
End Function
xmldoc.save difFile

if bFiltering then
    WshShell.Run "wscript """ & scriptdir & "exclude.vbs"" /diff:""" & difFile & """ /excl:""" & WScript.Arguments.Named("excl") & """"
end if

' If WScript.Arguments.Named.Exists("excl") Then
'	If WScript.Arguments.Named.Exists("drop") Then
'		WshShell.Run "wscript """ & scriptdir & "exclude.vbs"" /diff:""" & difFile & """ /excl:""" & WScript.Arguments.Named("excl") & """ /drop"
'	Else
'		WshShell.Run "wscript """ & scriptdir & "exclude.vbs"" /diff:""" & difFile & """ /excl:""" & WScript.Arguments.Named("excl") & """"
'	End If
' End If